--- net/minecraft/src/ItemBlock.java
+++ net/minecraft/src/ItemBlock.java
@@ -43,14 +43,47 @@
 		} else {
 			if(var3.canBlockBePlacedAt(this.blockID, var4, var5, var6, false)) {
 				Block var8 = Block.blocksList[this.blockID];
-				if(var3.setBlockWithNotify(var4, var5, var6, this.blockID)) {
+				if(var3.setBlockAndMetadataWithNotify(var4, var5, var6, this.blockID, var1.getItemDamageForDisplay())) {
 					Block.blocksList[this.blockID].onBlockPlaced(var3, var4, var5, var6, var7);
 					var3.playSoundEffect((double)((float)var4 + 0.5F), (double)((float)var5 + 0.5F), (double)((float)var6 + 0.5F), var8.stepSound.getStepSound(), (var8.stepSound.getVolume() + 1.0F) / 2.0F, var8.stepSound.getPitch() * 0.8F);
+					
 					--var1.stackSize;
 				}
 			}
 
 			return true;
 		}
+	}
+	
+	public boolean onPlace(ItemStack var1, EntityPlayer var2, World var3, int var4, int var5, int var6, int var7) {
+		if(var3.getBlockId(var4, var5, var6) == Block.snow.blockID) {
+			var7 = 0;
+		} else {
+			if(var7 == 0) {
+				--var5;
+			}
+
+			if(var7 == 1) {
+				++var5;
+			}
+
+			if(var7 == 2) {
+				--var6;
+			}
+
+			if(var7 == 3) {
+				++var6;
+			}
+
+			if(var7 == 4) {
+				--var4;
+			}
+
+			if(var7 == 5) {
+				++var4;
+			}
+		}
+
+		return var3.canBlockBePlacedAt(this.blockID, var4, var5, var6, false);
 	}
 }
--- net/minecraft/src/Packet31RelEntityMove.java
+++ net/minecraft/src/Packet31RelEntityMove.java
@@ -12,8 +12,8 @@
 		this.zPosition = var1.readByte();
 	}
 
-	public void writePacket(DataOutputStream var1) throws IOException {
-		super.writePacket(var1);
+	public void writePacketData(DataOutputStream var1) throws IOException {
+		super.writePacketData(var1);
 		var1.writeByte(this.xPosition);
 		var1.writeByte(this.yPosition);
 		var1.writeByte(this.zPosition);
--- net/minecraft/src/EntityItem.java
+++ net/minecraft/src/EntityItem.java
@@ -27,6 +27,9 @@
 		this.yOffset = this.height / 2.0F;
 	}
 
+	protected void entityInit() {
+	}
+
 	public void onUpdate() {
 		super.onUpdate();
 		if(this.delayBeforeCanPickup > 0) {
--- net/minecraft/src/Packet13PlayerLookMove.java
+++ net/minecraft/src/Packet13PlayerLookMove.java
@@ -32,14 +32,14 @@
 		super.readPacketData(var1);
 	}
 
-	public void writePacket(DataOutputStream var1) throws IOException {
+	public void writePacketData(DataOutputStream var1) throws IOException {
 		var1.writeDouble(this.xPosition);
 		var1.writeDouble(this.yPosition);
 		var1.writeDouble(this.stance);
 		var1.writeDouble(this.zPosition);
 		var1.writeFloat(this.yaw);
 		var1.writeFloat(this.pitch);
-		super.writePacket(var1);
+		super.writePacketData(var1);
 	}
 
 	public int getPacketSize() {
--- /dev/null
+++ net/minecraft/src/ICrafting.java
@@ -1,0 +1,7 @@
+package net.minecraft.src;
+
+public interface ICrafting {
+	void func_20159_a(Container var1, int var2, ItemStack var3);
+
+	void func_20158_a(Container var1, int var2, int var3);
+}
--- net/minecraft/src/RenderBlocks.java
+++ net/minecraft/src/RenderBlocks.java
@@ -1322,7 +1322,7 @@
 		}
 
 		var1.setBlockBounds(0.0F, 0.0F, 0.0F, 1.0F, 1.0F, 1.0F);
-		return var5;
+		return true;
 	}
 
 	public boolean renderBlockStairs(Block var1, int var2, int var3, int var4) {
@@ -1719,7 +1719,7 @@
 
 	}
 
-	public void renderBlockOnInventory(Block var1) {
+	public void renderBlockOnInventory(Block var1, int metadata) {
 		byte var2 = -1;
 		Tessellator var3 = Tessellator.instance;
 		int var4 = var1.getRenderType();
@@ -1728,27 +1728,27 @@
 			GL11.glTranslatef(-0.5F, -0.5F, -0.5F);
 			var3.startDrawingQuads();
 			var3.setNormal(0.0F, -1.0F, 0.0F);
-			this.renderBottomFace(var1, 0.0D, 0.0D, 0.0D, var1.getBlockTextureFromSide(0));
+			this.renderBottomFace(var1, 0.0D, 0.0D, 0.0D, var1.getBlockTextureFromSideAndMetadata(0, metadata));
 			var3.draw();
 			var3.startDrawingQuads();
 			var3.setNormal(0.0F, 1.0F, 0.0F);
-			this.renderTopFace(var1, 0.0D, 0.0D, 0.0D, var1.getBlockTextureFromSide(1));
+			this.renderTopFace(var1, 0.0D, 0.0D, 0.0D, var1.getBlockTextureFromSideAndMetadata(1, metadata));
 			var3.draw();
 			var3.startDrawingQuads();
 			var3.setNormal(0.0F, 0.0F, -1.0F);
-			this.renderEastFace(var1, 0.0D, 0.0D, 0.0D, var1.getBlockTextureFromSide(2));
+			this.renderEastFace(var1, 0.0D, 0.0D, 0.0D, var1.getBlockTextureFromSideAndMetadata(2, metadata));
 			var3.draw();
 			var3.startDrawingQuads();
 			var3.setNormal(0.0F, 0.0F, 1.0F);
-			this.renderWestFace(var1, 0.0D, 0.0D, 0.0D, var1.getBlockTextureFromSide(3));
+			this.renderWestFace(var1, 0.0D, 0.0D, 0.0D, var1.getBlockTextureFromSideAndMetadata(3, metadata));
 			var3.draw();
 			var3.startDrawingQuads();
 			var3.setNormal(-1.0F, 0.0F, 0.0F);
-			this.renderNorthFace(var1, 0.0D, 0.0D, 0.0D, var1.getBlockTextureFromSide(4));
+			this.renderNorthFace(var1, 0.0D, 0.0D, 0.0D, var1.getBlockTextureFromSideAndMetadata(4, metadata));
 			var3.draw();
 			var3.startDrawingQuads();
 			var3.setNormal(1.0F, 0.0F, 0.0F);
-			this.renderSouthFace(var1, 0.0D, 0.0D, 0.0D, var1.getBlockTextureFromSide(5));
+			this.renderSouthFace(var1, 0.0D, 0.0D, 0.0D, var1.getBlockTextureFromSideAndMetadata(5, metadata));
 			var3.draw();
 			GL11.glTranslatef(0.5F, 0.5F, 0.5F);
 		} else if(var4 == 1) {
--- net/minecraft/src/World.java
+++ net/minecraft/src/World.java
@@ -890,12 +890,29 @@
 	}
 
 	public void setEntityDead(Entity var1) {
+		if (var1.riddenByEntity != null) {
+			var1.riddenByEntity.mountEntity(null);
+		}
+
+		if (var1.ridingEntity != null) {
+			var1.mountEntity(null);
+		}
+		
 		var1.setEntityDead();
 		if(var1 instanceof EntityPlayer) {
 			this.playerEntities.remove((EntityPlayer)var1);
 			System.out.println("Player count: " + this.playerEntities.size());
 		}
 
+//		int i = var1.chunkCoordX;
+//		int j = var1.chunkCoordZ;
+//		if (var1.addedToChunk && this.chunkExists(i, j)) {
+//			this.getChunkFromChunkCoords(i, j).removeEntity(var1);
+//		}
+//
+//		this.loadedEntityList.remove(var1);
+//		this.releaseEntitySkin(var1);
+
 	}
 
 	public void addWorldAccess(IWorldAccess var1) {
@@ -1363,8 +1380,16 @@
 		return false;
 	}
 
-	public void createExplosion(Entity var1, double var2, double var4, double var6, float var8) {
-		(new Explosion()).doExplosion(this, var1, var2, var4, var6, var8);
+	public Explosion createExplosion(Entity var1, double var2, double var4, double var6, float var8) {
+		return this.newExplosion(var1, var2, var4, var6, var8, false);
+	}
+
+	public Explosion newExplosion(Entity var1, double var2, double var4, double var6, float var8, boolean var9) {
+		Explosion var10 = new Explosion(this, var1, var2, var4, var6, var8);
+		var10.isFlaming = var9;
+		var10.doExplosionA();
+		var10.doExplosionB(true);
+		return var10;
 	}
 
 	public float getBlockDensity(Vec3D var1, AxisAlignedBB var2) {
@@ -1392,7 +1417,7 @@
 		return (float)var9 / (float)var10;
 	}
 
-	public void extinguishFire(int var1, int var2, int var3, int var4) {
+	public boolean extinguishFire(EntityPlayer player, int var1, int var2, int var3, int var4) {
 		if(var4 == 0) {
 			--var2;
 		}
@@ -1418,9 +1443,13 @@
 		}
 
 		if(this.getBlockId(var1, var2, var3) == Block.fire.blockID) {
-			this.playSoundEffect((double)((float)var1 + 0.5F), (double)((float)var2 + 0.5F), (double)((float)var3 + 0.5F), "random.fizz", 0.5F, 2.6F + (this.rand.nextFloat() - this.rand.nextFloat()) * 0.8F);
+			if (!this.multiplayerWorld)
+				this.func_28107_a(player, 1004, var2, var3, var4, 0);
+			
 			this.setBlockWithNotify(var1, var2, var3, 0);
+	         return true;
 		}
+        return false;
 
 	}
 
@@ -1920,6 +1949,17 @@
 		if(!this.loadedEntityList.contains(var1)) {
 			System.out.println("REINSERTING PLAYER!");
 			this.loadedEntityList.add(var1);
+		}
+
+	}
+	
+	public void func_28106_e(int var1, int var2, int var3, int var4, int var5) {
+		this.func_28107_a((EntityPlayer)null, var1, var2, var3, var4, var5);
+	}
+
+	public void func_28107_a(EntityPlayer var1, int var2, int var3, int var4, int var5, int var6) {
+		for(int var7 = 0; var7 < this.worldAccesses.size(); ++var7) {
+			((IWorldAccess)this.worldAccesses.get(var7)).func_28136_a(var1, var2, var3, var4, var5, var6);
 		}
 
 	}
--- net/minecraft/src/TextureCompassFX.java
+++ net/minecraft/src/TextureCompassFX.java
@@ -14,7 +14,7 @@
 	private double angleDelta;
 
 	public TextureCompassFX(Minecraft var1) {
-		super(Item.compass.getIconIndex((ItemStack)null));
+		super(Item.compass.getSprite(0));
 		this.mc = var1;
 		this.tileImage = 1;
 
--- net/minecraft/src/ItemSign.java
+++ net/minecraft/src/ItemSign.java
@@ -43,7 +43,10 @@
 				}
 
 				--var1.stackSize;
-				var2.displayGUIEditSign((TileEntitySign)var3.getBlockTileEntity(var4, var5, var6));
+				TileEntitySign var8 = (TileEntitySign)var3.getBlockTileEntity(var4, var5, var6);
+				if(var8 != null) {
+					var2.displayGUIEditSign(var8);
+				}
 				return true;
 			}
 		}
--- /dev/null
+++ net/minecraft/src/Packet200Statistic.java
@@ -1,0 +1,28 @@
+package net.minecraft.src;
+
+import java.io.DataInputStream;
+import java.io.DataOutputStream;
+import java.io.IOException;
+
+public class Packet200Statistic extends Packet {
+	public int field_27052_a;
+	public int field_27051_b;
+
+	public void processPacket(NetHandler var1) {
+		var1.func_27245_a(this);
+	}
+
+	public void readPacketData(DataInputStream var1) throws IOException {
+		this.field_27052_a = var1.readInt();
+		this.field_27051_b = var1.readByte();
+	}
+
+	public void writePacketData(DataOutputStream var1) throws IOException {
+		var1.writeInt(this.field_27052_a);
+		var1.writeByte(this.field_27051_b);
+	}
+
+	public int getPacketSize() {
+		return 6;
+	}
+}
--- net/minecraft/src/EntityPig.java
+++ net/minecraft/src/EntityPig.java
@@ -1,23 +1,25 @@
 package net.minecraft.src;
 
 public class EntityPig extends EntityAnimal {
-	public boolean saddled = false;
 
 	public EntityPig(World var1) {
 		super(var1);
 		this.texture = "/mob/pig.png";
 		this.setSize(0.9F, 0.9F);
-		this.saddled = false;
+	}
+
+	protected void entityInit() {
+		this.dataWatcher.addObject(16, Byte.valueOf((byte)0));
 	}
 
 	public void writeEntityToNBT(NBTTagCompound var1) {
 		super.writeEntityToNBT(var1);
-		var1.setBoolean("Saddle", this.saddled);
+		var1.setBoolean("Saddle", this.getSaddled());
 	}
 
 	public void readEntityFromNBT(NBTTagCompound var1) {
 		super.readEntityFromNBT(var1);
-		this.saddled = var1.getBoolean("Saddle");
+		this.setSaddled(var1.getBoolean("Saddle"));
 	}
 
 	protected String getLivingSound() {
@@ -33,15 +35,28 @@
 	}
 
 	public boolean interact(EntityPlayer var1) {
-		if(this.saddled) {
+		if(!this.getSaddled() || this.worldObj.multiplayerWorld || this.riddenByEntity != null && this.riddenByEntity != var1) {
+			return false;
+		} else {
 			var1.mountEntity(this);
 			return true;
-		} else {
-			return false;
 		}
 	}
 
 	protected int getDropItemId() {
 		return Item.porkRaw.shiftedIndex;
+	}
+	
+	public boolean getSaddled() {
+		return (this.dataWatcher.getWatchableObjectByte(16) & 1) != 0;
+	}
+
+	public void setSaddled(boolean var1) {
+		if(var1) {
+			this.dataWatcher.updateObject(16, Byte.valueOf((byte)1));
+		} else {
+			this.dataWatcher.updateObject(16, Byte.valueOf((byte)0));
+		}
+
 	}
 }
--- net/minecraft/src/RenderSnowball.java
+++ net/minecraft/src/RenderSnowball.java
@@ -9,7 +9,7 @@
 		GL11.glTranslatef((float)var2, (float)var4, (float)var6);
 		GL11.glEnable(GL12.GL_RESCALE_NORMAL);
 		GL11.glScalef(0.5F, 0.5F, 0.5F);
-		int var10 = Item.snowball.getIconIndex((ItemStack)null);
+		int var10 = Item.snowball.getSprite(0);
 		this.loadTexture("/gui/items.png");
 		Tessellator var11 = Tessellator.instance;
 		float var12 = (float)(var10 % 16 * 16 + 0) / 256.0F;
--- net/minecraft/src/BlockSnow.java
+++ net/minecraft/src/BlockSnow.java
@@ -46,7 +46,7 @@
 		double var8 = (double)(var1.rand.nextFloat() * var7) + (double)(1.0F - var7) * 0.5D;
 		double var10 = (double)(var1.rand.nextFloat() * var7) + (double)(1.0F - var7) * 0.5D;
 		double var12 = (double)(var1.rand.nextFloat() * var7) + (double)(1.0F - var7) * 0.5D;
-		EntityItem var14 = new EntityItem(var1, (double)var2 + var8, (double)var3 + var10, (double)var4 + var12, new ItemStack(var6));
+		EntityItem var14 = new EntityItem(var1, (double)var2 + var8, (double)var3 + var10, (double)var4 + var12, new ItemStack(var6, 1, 0));
 		var14.delayBeforeCanPickup = 10;
 		var1.spawnEntityInWorld(var14);
 		var1.setBlockWithNotify(var2, var3, var4, 0);
--- net/minecraft/src/EntityRenderer.java
+++ net/minecraft/src/EntityRenderer.java
@@ -1,9 +1,11 @@
 package net.minecraft.src;
 
 import java.nio.FloatBuffer;
+import java.util.ArrayList;
+import java.util.HashMap;
 import java.util.List;
 import java.util.Random;
-import net.minecraft.client.Minecraft;
+
 import org.lwjgl.input.Mouse;
 import org.lwjgl.opengl.Display;
 import org.lwjgl.opengl.GL11;
@@ -11,6 +13,8 @@
 import org.lwjgl.opengl.NVFogDistance;
 import org.lwjgl.util.glu.GLU;
 
+import net.minecraft.client.Minecraft;
+
 public class EntityRenderer {
 	private Minecraft mc;
 	private float farPlaneDistance = 0.0F;
@@ -376,6 +380,13 @@
 				GL11.glEnable(GL11.GL_ALPHA_TEST);
 			}
 
+			// uberbukkit start
+			GL11.glEnable(GL11.GL_BLEND);
+			GL11.glBlendFunc(GL11.GL_SRC_ALPHA, GL11.GL_ONE);
+			var3.drawBlockBreaking(var2, var1);
+			GL11.glDisable(GL11.GL_BLEND);
+			// uberbukkit end
+			
 			GL11.glDisable(GL11.GL_FOG);
 			if(this.mc.theWorld.snowCovered) {
 				this.renderSnow(var1);
--- net/minecraft/src/Packet32EntityLook.java
+++ net/minecraft/src/Packet32EntityLook.java
@@ -15,8 +15,8 @@
 		this.pitch = var1.readByte();
 	}
 
-	public void writePacket(DataOutputStream var1) throws IOException {
-		super.writePacket(var1);
+	public void writePacketData(DataOutputStream var1) throws IOException {
+		super.writePacketData(var1);
 		var1.writeByte(this.yaw);
 		var1.writeByte(this.pitch);
 	}
--- net/minecraft/src/PlayerControllerCreative.java
+++ net/minecraft/src/PlayerControllerCreative.java
@@ -11,7 +11,7 @@
 	public void onRespawn(EntityPlayer var1) {
 		for(int var2 = 0; var2 < 9; ++var2) {
 			if(var1.inventory.mainInventory[var2] == null) {
-				this.mc.thePlayer.inventory.mainInventory[var2] = new ItemStack(((Block)Session.registeredBlocksList.get(var2)).blockID);
+				this.mc.thePlayer.inventory.mainInventory[var2] = new ItemStack(((Block)Session.registeredBlocksList.get(var2)));
 			} else {
 				this.mc.thePlayer.inventory.mainInventory[var2].stackSize = 1;
 			}
--- net/minecraft/src/BlockLever.java
+++ net/minecraft/src/BlockLever.java
@@ -133,12 +133,16 @@
 	}
 
 	public boolean blockActivated(World var1, int var2, int var3, int var4, EntityPlayer var5) {
+		if (var1.multiplayerWorld) {
+			return true;
+		}
 		int var6 = var1.getBlockMetadata(var2, var3, var4);
 		int var7 = var6 & 7;
 		int var8 = 8 - (var6 & 8);
 		var1.setBlockMetadataWithNotify(var2, var3, var4, var7 + var8);
 		var1.markBlocksDirty(var2, var3, var4, var2, var3, var4);
 		var1.playSoundEffect((double)var2 + 0.5D, (double)var3 + 0.5D, (double)var4 + 0.5D, "random.click", 0.3F, var8 > 0 ? 0.6F : 0.5F);
+		
 		var1.notifyBlocksOfNeighborChange(var2, var3, var4, this.blockID);
 		if(var7 == 1) {
 			var1.notifyBlocksOfNeighborChange(var2 - 1, var3, var4, this.blockID);
--- net/minecraft/src/EntityArrow.java
+++ net/minecraft/src/EntityArrow.java
@@ -9,7 +9,7 @@
 	private int inTile = 0;
 	private boolean inData = false;
 	public int arrowShake = 0;
-	private EntityLiving shootingEntity;
+	public EntityLiving shootingEntity;
 	private int ticksInGround;
 	private int ticksInAir = 0;
 
@@ -17,6 +17,13 @@
 		super(var1);
 		this.setSize(0.5F, 0.5F);
 	}
+	
+	public EntityArrow(World var1, double var2, double var4, double var6) {
+		super(var1);
+		this.setSize(0.5F, 0.5F);
+		this.setPosition(var2, var4, var6);
+		this.yOffset = 0.0F;
+	}
 
 	public EntityArrow(World var1, EntityLiving var2) {
 		super(var1);
@@ -34,6 +41,9 @@
 		this.setArrowHeading(this.motionX, this.motionY, this.motionZ, 1.5F, 1.0F);
 	}
 
+	protected void entityInit() {
+	}
+
 	public void setArrowHeading(double var1, double var3, double var5, float var7, float var8) {
 		float var9 = MathHelper.sqrt_double(var1 * var1 + var3 * var3 + var5 * var5);
 		var1 /= (double)var9;
@@ -54,8 +64,39 @@
 		this.ticksInGround = 0;
 	}
 
+	@Override
+	public void setVelocity(double velocityX, double velocityY, double velocityZ) {
+		this.motionX = velocityX;
+		this.motionY = velocityY;
+		this.motionZ = velocityZ;
+		if (this.prevRotationPitch == 0.0F && this.prevRotationYaw == 0.0F) {
+			float f = MathHelper.sqrt_double(velocityX * velocityX + velocityZ * velocityZ);
+			this.prevRotationYaw = this.rotationYaw = (float)(Math.atan2(velocityX, velocityZ) * 180.0 / (float) Math.PI);
+			this.prevRotationPitch = this.rotationPitch = (float)(Math.atan2(velocityY, f) * 180.0 / (float) Math.PI);
+			this.prevRotationPitch = this.rotationPitch;
+			this.prevRotationYaw = this.rotationYaw;
+			this.setLocationAndAngles(this.posX, this.posY, this.posZ, this.rotationYaw, this.rotationPitch);
+			this.ticksInGround = 0;
+		}
+	}
+
 	public void onUpdate() {
 		super.onUpdate();
+		if (this.prevRotationPitch == 0.0F && this.prevRotationYaw == 0.0F) {
+			float f = MathHelper.sqrt_double(this.motionX * this.motionX + this.motionZ * this.motionZ);
+			this.prevRotationYaw = this.rotationYaw = (float)(Math.atan2(this.motionX, this.motionZ) * 180.0 / (float) Math.PI);
+			this.prevRotationPitch = this.rotationPitch = (float)(Math.atan2(this.motionY, f) * 180.0 / (float) Math.PI);
+		}
+
+		int i = this.worldObj.getBlockId(this.xTile, this.yTile, this.zTile);
+		if (i > 0) {
+			Block.blocksList[i].setBlockBoundsBasedOnState(this.worldObj, this.xTile, this.yTile, this.zTile);
+			AxisAlignedBB box = Block.blocksList[i].getCollisionBoundingBoxFromPool(this.worldObj, this.xTile, this.yTile, this.zTile);
+			if (box != null && box.contains(Vec3D.createVector(this.posX, this.posY, this.posZ))) {
+				this.inData = true;
+			}
+		}
+
 		if(this.arrowShake > 0) {
 			--this.arrowShake;
 		}
@@ -119,7 +160,9 @@
 		if(var3 != null) {
 			if(var3.entityHit != null) {
 				if(var3.entityHit.attackEntityFrom(this.shootingEntity, 4)) {
-					this.worldObj.playSoundAtEntity(this, "random.drr", 1.0F, 1.2F / (this.rand.nextFloat() * 0.2F + 0.9F));
+					if (!this.worldObj.multiplayerWorld)
+						this.worldObj.playSoundAtEntity(this, "random.drr", 1.0F, 1.2F / (this.rand.nextFloat() * 0.2F + 0.9F));
+					
 					this.setEntityDead();
 				} else {
 					this.motionX *= (double)-0.1F;
@@ -141,7 +184,9 @@
 				this.posX -= this.motionX / (double)var16 * (double)0.05F;
 				this.posY -= this.motionY / (double)var16 * (double)0.05F;
 				this.posZ -= this.motionZ / (double)var16 * (double)0.05F;
-				this.worldObj.playSoundAtEntity(this, "random.drr", 1.0F, 1.2F / (this.rand.nextFloat() * 0.2F + 0.9F));
+				if (!this.worldObj.multiplayerWorld)
+					this.worldObj.playSoundAtEntity(this, "random.drr", 1.0F, 1.2F / (this.rand.nextFloat() * 0.2F + 0.9F));
+				
 				this.inData = true;
 				this.arrowShake = 7;
 			}
@@ -207,7 +252,10 @@
 	}
 
 	public void onCollideWithPlayer(EntityPlayer var1) {
-		if(this.inData && this.shootingEntity == var1 && this.arrowShake <= 0 && var1.inventory.addItemStackToInventory(new ItemStack(Item.arrow.shiftedIndex, 1))) {
+		if (this.worldObj.multiplayerWorld)
+			return;
+		
+		if(this.inData && this.shootingEntity == var1 && this.arrowShake <= 0 && var1.inventory.addItemStackToInventory(new ItemStack(Item.arrow.shiftedIndex, 1, 0))) {
 			this.worldObj.playSoundAtEntity(this, "random.pop", 0.2F, ((this.rand.nextFloat() - this.rand.nextFloat()) * 0.7F + 1.0F) * 2.0F);
 			var1.onItemPickup(this, 1);
 			this.setEntityDead();
--- /dev/null
+++ net/minecraft/src/IRecipe.java
@@ -1,0 +1,11 @@
+package net.minecraft.src;
+
+public interface IRecipe {
+	boolean matches(InventoryCrafting var1);
+
+	ItemStack getCraftingResult(InventoryCrafting var1);
+
+	int getRecipeSize();
+
+	ItemStack getRecipeOutput();
+}
--- net/minecraft/src/GuiInventory.java
+++ net/minecraft/src/GuiInventory.java
@@ -4,37 +4,17 @@
 import org.lwjgl.opengl.GL12;
 
 public class GuiInventory extends GuiContainer {
-	private CraftingInventoryPlayerCB craftingInventory;
 	private float xSize_lo;
 	private float ySize_lo;
 
-	public GuiInventory(IInventory var1, ItemStack[] var2) {
+	public GuiInventory(EntityPlayer var1) {
+		super(var1.inventorySlots);
 		this.allowUserInput = true;
-		this.craftingInventory = new CraftingInventoryPlayerCB(var2);
-		this.inventorySlots.add(new SlotCrafting(this, this.craftingInventory.craftMatrix, this.craftingInventory.craftResult, 0, 144, 36));
-
-		int var3;
-		int var4;
-		for(var3 = 0; var3 < 2; ++var3) {
-			for(var4 = 0; var4 < 2; ++var4) {
-				this.inventorySlots.add(new SlotInventory(this, this.craftingInventory.craftMatrix, var4 + var3 * 2, 88 + var4 * 18, 26 + var3 * 18));
-			}
-		}
-
-		for(var3 = 0; var3 < 4; ++var3) {
-			this.inventorySlots.add(new SlotArmor(this, this, var1, var1.getSizeInventory() - 1 - var3, 8, 8 + var3 * 18, var3));
-		}
-
-		for(var3 = 0; var3 < 3; ++var3) {
-			for(var4 = 0; var4 < 9; ++var4) {
-				this.inventorySlots.add(new SlotInventory(this, var1, var4 + (var3 + 1) * 9, 8 + var4 * 18, 84 + var3 * 18));
-			}
-		}
-
-		for(var3 = 0; var3 < 9; ++var3) {
-			this.inventorySlots.add(new SlotInventory(this, var1, var3, 8 + var3 * 18, 142));
-		}
-
+
+	}
+	
+	public void initGui() {
+		this.controlList.clear();
 	}
 
 	protected void drawGuiContainerForegroundLayer() {
--- net/minecraft/src/Packet3Chat.java
+++ net/minecraft/src/Packet3Chat.java
@@ -11,15 +11,19 @@
 	}
 
 	public Packet3Chat(String var1) {
+		if(var1.length() > 119) {
+			var1 = var1.substring(0, 119);
+		}
+
 		this.message = var1;
 	}
 
 	public void readPacketData(DataInputStream var1) throws IOException {
-		this.message = var1.readUTF();
+		this.message = readString(var1, 119);
 	}
 
-	public void writePacket(DataOutputStream var1) throws IOException {
-		var1.writeUTF(this.message);
+	public void writePacketData(DataOutputStream var1) throws IOException {
+		writeString(this.message, var1);
 	}
 
 	public void processPacket(NetHandler var1) {
--- /dev/null
+++ net/minecraft/src/WatchableObject.java
@@ -1,0 +1,35 @@
+package net.minecraft.src;
+
+public class WatchableObject {
+	private final int objectType;
+	private final int dataValueId;
+	private Object watchedObject;
+	private boolean isWatching;
+
+	public WatchableObject(int var1, int var2, Object var3) {
+		this.dataValueId = var2;
+		this.watchedObject = var3;
+		this.objectType = var1;
+		this.isWatching = true;
+	}
+
+	public int getDataValueId() {
+		return this.dataValueId;
+	}
+
+	public void setObject(Object var1) {
+		this.watchedObject = var1;
+	}
+
+	public Object getObject() {
+		return this.watchedObject;
+	}
+
+	public int getObjectType() {
+		return this.objectType;
+	}
+
+	public void setWatching(boolean var1) {
+		this.isWatching = var1;
+	}
+}
--- net/minecraft/src/Packet255KickDisconnect.java
+++ net/minecraft/src/Packet255KickDisconnect.java
@@ -15,11 +15,11 @@
 	}
 
 	public void readPacketData(DataInputStream var1) throws IOException {
-		this.reason = var1.readUTF();
+		this.reason = readString(var1, 100);
 	}
 
-	public void writePacket(DataOutputStream var1) throws IOException {
-		var1.writeUTF(this.reason);
+	public void writePacketData(DataOutputStream var1) throws IOException {
+		writeString(this.reason, var1);
 	}
 
 	public void processPacket(NetHandler var1) {
--- net/minecraft/src/Packet1Login.java
+++ net/minecraft/src/Packet1Login.java
@@ -7,27 +7,29 @@
 public class Packet1Login extends Packet {
 	public int protocolVersion;
 	public String username;
-	public String password;
+	public long mapSeed;
+	public byte dimension;
 
 	public Packet1Login() {
 	}
 
-	public Packet1Login(String var1, String var2, int var3) {
+	public Packet1Login(String var1, int var2) {
 		this.username = var1;
-		this.password = var2;
-		this.protocolVersion = var3;
+		this.protocolVersion = var2;
 	}
 
 	public void readPacketData(DataInputStream var1) throws IOException {
 		this.protocolVersion = var1.readInt();
-		this.username = var1.readUTF();
-		this.password = var1.readUTF();
+		this.username = readString(var1, 16);
+		this.mapSeed = var1.readLong();
+		this.dimension = var1.readByte();
 	}
 
-	public void writePacket(DataOutputStream var1) throws IOException {
+	public void writePacketData(DataOutputStream var1) throws IOException {
 		var1.writeInt(this.protocolVersion);
-		var1.writeUTF(this.username);
-		var1.writeUTF(this.password);
+		writeString(this.username, var1);
+		var1.writeLong(this.mapSeed);
+		var1.writeByte(this.dimension);
 	}
 
 	public void processPacket(NetHandler var1) {
@@ -35,6 +37,6 @@
 	}
 
 	public int getPacketSize() {
-		return 4 + this.username.length() + this.password.length() + 4;
+		return 4 + this.username.length() + 4 + 5;
 	}
 }
--- net/minecraft/src/IWorldAccess.java
+++ net/minecraft/src/IWorldAccess.java
@@ -18,4 +18,8 @@
 	void playRecord(String var1, int var2, int var3, int var4);
 
 	void doNothingWithTileEntity(int var1, int var2, int var3, TileEntity var4);
+
+	void func_28136_a(EntityPlayer var1, int var2, int var3, int var4, int var5, int var6);
+
+	void updateBlockMiningProgress(int id, int x, int y, int z, int progress);
 }
--- net/minecraft/src/RenderSlime.java
+++ net/minecraft/src/RenderSlime.java
@@ -28,9 +28,9 @@
 	}
 
 	protected void squishSlime(EntitySlime var1, float var2) {
-		float var3 = (var1.prevSquishFactor + (var1.squishFactor - var1.prevSquishFactor) * var2) / ((float)var1.size * 0.5F + 1.0F);
+		float var3 = (var1.prevSquishFactor + (var1.squishFactor - var1.prevSquishFactor) * var2) / ((float)var1.getSlimeSize() * 0.5F + 1.0F);
 		float var4 = 1.0F / (var3 + 1.0F);
-		float var5 = (float)var1.size;
+		float var5 = (float)var1.getSlimeSize();
 		GL11.glScalef(var4 * var5, 1.0F / var4 * var5, var4 * var5);
 	}
 
--- /dev/null
+++ net/minecraft/src/BlockWool.java
@@ -1,0 +1,30 @@
+package net.minecraft.src;
+
+public class BlockWool extends Block {
+	public BlockWool() {
+		super(35, 64, Material.cloth);
+	}
+
+	@Override
+	public int getBlockTextureFromSideAndMetadata(int face, int metadata) {
+		if (metadata == 0) {
+			return this.blockIndexInTexture;
+		} else {
+			metadata = ~(metadata & 15);
+			return 113 + ((metadata & 8) >> 3) + (metadata & 7) * 16;
+		}
+	}
+
+	@Override
+	protected int damageDropped(int metadata) {
+		return metadata;
+	}
+
+	public static int getBlockMetadataForItemMetadata(int metadata) {
+		return ~metadata & 15;
+	}
+
+	public static int getItemMetadataForBlockMetadata(int metadata) {
+		return ~metadata & 15;
+	}
+}
--- /dev/null
+++ net/minecraft/src/Packet103SetSlot.java
@@ -1,0 +1,46 @@
+package net.minecraft.src;
+
+import java.io.DataInputStream;
+import java.io.DataOutputStream;
+import java.io.IOException;
+
+public class Packet103SetSlot extends Packet {
+	public int windowId;
+	public int itemSlot;
+	public ItemStack myItemStack;
+
+	public void processPacket(NetHandler var1) {
+		var1.func_20088_a(this);
+	}
+
+	public void readPacketData(DataInputStream var1) throws IOException {
+		this.windowId = var1.readByte();
+		this.itemSlot = var1.readShort();
+		short var2 = var1.readShort();
+		if(var2 >= 0) {
+			byte var3 = var1.readByte();
+			short var4 = var1.readShort();
+			this.myItemStack = new ItemStack(var2, var3, var4);
+		} else {
+			this.myItemStack = null;
+		}
+
+	}
+
+	public void writePacketData(DataOutputStream var1) throws IOException {
+		var1.writeByte(this.windowId);
+		var1.writeShort(this.itemSlot);
+		if(this.myItemStack == null) {
+			var1.writeShort(-1);
+		} else {
+			var1.writeShort(this.myItemStack.itemID);
+			var1.writeByte(this.myItemStack.stackSize);
+			var1.writeShort(this.myItemStack.getItemDamage());
+		}
+
+	}
+
+	public int getPacketSize() {
+		return 8;
+	}
+}
--- net/minecraft/src/EntityCreature.java
+++ net/minecraft/src/EntityCreature.java
@@ -23,6 +23,8 @@
 			float var2 = this.entityToAttack.getDistanceToEntity(this);
 			if(this.canEntityBeSeen(this.entityToAttack)) {
 				this.attackEntity(this.entityToAttack, var2);
+			} else {
+				this.attackBlockedEntity(this.entityToAttack, var2);
 			}
 		}
 
@@ -133,6 +135,9 @@
 
 	protected void attackEntity(Entity var1, float var2) {
 	}
+	
+	protected void attackBlockedEntity(Entity var1, float var2) {
+	}
 
 	protected float getBlockPathWeight(int var1, int var2, int var3) {
 		return 0.0F;
@@ -147,5 +152,21 @@
 		int var2 = MathHelper.floor_double(this.boundingBox.minY);
 		int var3 = MathHelper.floor_double(this.posZ);
 		return super.getCanSpawnHere() && this.getBlockPathWeight(var1, var2, var3) >= 0.0F;
+	}
+	
+	public boolean hasPath() {
+		return this.pathToEntity != null;
+	}
+
+	public void setPathToEntity(PathEntity var1) {
+		this.pathToEntity = var1;
+	}
+
+	public Entity getTarget() {
+		return this.entityToAttack;
+	}
+
+	public void setTarget(Entity var1) {
+		this.entityToAttack = var1;
 	}
 }
--- /dev/null
+++ net/minecraft/src/Packet54PlayNoteBlock.java
@@ -1,0 +1,37 @@
+package net.minecraft.src;
+
+import java.io.DataInputStream;
+import java.io.DataOutputStream;
+import java.io.IOException;
+
+public class Packet54PlayNoteBlock extends Packet {
+	public int xLocation;
+	public int yLocation;
+	public int zLocation;
+	public int instrumentType;
+	public int pitch;
+
+	public void readPacketData(DataInputStream var1) throws IOException {
+		this.xLocation = var1.readInt();
+		this.yLocation = var1.readShort();
+		this.zLocation = var1.readInt();
+		this.instrumentType = var1.read();
+		this.pitch = var1.read();
+	}
+
+	public void writePacketData(DataOutputStream var1) throws IOException {
+		var1.writeInt(this.xLocation);
+		var1.writeShort(this.yLocation);
+		var1.writeInt(this.zLocation);
+		var1.write(this.instrumentType);
+		var1.write(this.pitch);
+	}
+
+	public void processPacket(NetHandler var1) {
+		var1.handleNotePlay(this);
+	}
+
+	public int getPacketSize() {
+		return 12;
+	}
+}
--- net/minecraft/src/Packet10Flying.java
+++ net/minecraft/src/Packet10Flying.java
@@ -30,7 +30,7 @@
 		this.onGround = var1.read() != 0;
 	}
 
-	public void writePacket(DataOutputStream var1) throws IOException {
+	public void writePacketData(DataOutputStream var1) throws IOException {
 		var1.write(this.onGround ? 1 : 0);
 	}
 
--- /dev/null
+++ net/minecraft/src/Packet62Sound.java
@@ -1,0 +1,36 @@
+package net.minecraft.src;
+
+import java.io.DataInputStream;
+import java.io.DataOutputStream;
+import java.io.IOException;
+
+public class Packet62Sound extends Packet {
+	public String sound;
+	public double locX;
+	public double locY;
+	public double locZ;
+	public float f;
+	public float f1;
+
+	public Packet62Sound() {}
+
+	public void readPacketData(DataInputStream datainputstream) throws IOException {
+		this.sound = datainputstream.readUTF();
+		this.locX = datainputstream.readDouble();
+		this.locY = datainputstream.readDouble();
+		this.locZ = datainputstream.readDouble();
+		this.f = datainputstream.readFloat();
+		this.f1 = datainputstream.readFloat();
+	}
+
+	public void writePacketData(DataOutputStream dataoutputstream) throws IOException {
+	}
+
+	public void processPacket(NetHandler nethandler) {
+		nethandler.handle62Sound(this);
+	}
+
+	public int getPacketSize() {
+		return this.sound.length() + 8 * 3 + 4 * 2;
+	}
+}
--- net/minecraft/src/BlockRedstoneOre.java
+++ net/minecraft/src/BlockRedstoneOre.java
@@ -34,6 +34,9 @@
 	}
 
 	private void glow(World var1, int var2, int var3, int var4) {
+		if (var1.multiplayerWorld) {
+			return;
+		}
 		this.sparkle(var1, var2, var3, var4);
 		if(this.blockID == Block.oreRedstone.blockID) {
 			var1.setBlockWithNotify(var2, var3, var4, Block.oreRedstoneGlowing.blockID);
